<ToolboxBitmap(GetType(HRectGauge), "tbxHRectGauge.bmp")> _
Public Class HRectGauge
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'HRectGauge overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'HRectGauge
        '
        Me.Name = "HRectGauge"
        Me.Size = New System.Drawing.Size(264, 16)

    End Sub

#End Region

    Public Event ValueChanged()

    Private m_BorderStyle As BorderStyle = BorderStyle.Fixed3D
    Private m_Minimum As Integer = 0
    Private m_Maximum As Integer = 100
    Private m_Value As Integer = 75

    Public Property Minimum() As Integer
        Get
            Return m_Minimum
        End Get
        Set(ByVal Value As Integer)
            m_Minimum = Value
            DrawGauge()
        End Set
    End Property

    Public Property Maximum() As Integer
        Get
            Return m_Maximum
        End Get
        Set(ByVal Value As Integer)
            m_Maximum = Value
            DrawGauge()
        End Set
    End Property

    Public Property Value() As Integer
        Get
            Return m_Value
        End Get
        Set(ByVal Value As Integer)
            m_Value = Value
            DrawGauge()
            RaiseEvent ValueChanged()
        End Set
    End Property

    Public Property BorderStyle() As BorderStyle
        Get
            Return m_BorderStyle
        End Get
        Set(ByVal Value As BorderStyle)
            m_BorderStyle = Value
            DrawGauge()
        End Set
    End Property

    ' Draw the gauge.
    Private Sub DrawGauge()
        If m_Minimum >= m_Maximum Then Exit Sub

        ' Fill the bar.
        Dim gr As Graphics = Me.CreateGraphics()
        gr.Clear(Me.BackColor)
        gr.FillRectangle( _
            New SolidBrush(Me.ForeColor), _
            0, 0, _
            CInt(Me.DisplayRectangle.Width * m_Value / (m_Maximum - m_Minimum)), _
            Me.DisplayRectangle.Height)

        ' Draw the border.
        DrawBorder(gr, Me.DisplayRectangle, m_BorderStyle)
    End Sub

    ' Draw a border inside this rectangle.
    Private Sub DrawBorder(ByVal gr As Graphics, ByVal rect As Rectangle, ByVal border_style As BorderStyle, Optional ByVal sunken As Boolean = True)
        Select Case border_style
            Case BorderStyle.FixedSingle
                rect.Width -= 1
                rect.Height -= 1
                gr.DrawRectangle(Pens.Black, rect)
            Case BorderStyle.Fixed3D
                Dim colors() As Color
                If sunken Then
                    colors = New Color() { _
                        SystemColors.ControlDark, _
                        SystemColors.ControlDarkDark, _
                        SystemColors.ControlLightLight, _
                        SystemColors.ControlLight _
                    }
                Else
                    colors = New Color() { _
                        SystemColors.ControlLightLight, _
                        SystemColors.ControlLight, _
                        SystemColors.ControlDark, _
                        SystemColors.ControlDarkDark _
                    }
                End If
                Dim p As Pen
                p = New Pen(colors(0))
                gr.DrawLine(p, rect.X, rect.Y + rect.Height - 1, rect.X, rect.Y)
                gr.DrawLine(p, rect.X, rect.Y, rect.X + rect.Width - 1, rect.Y)
                p = New Pen(colors(1))
                gr.DrawLine(p, rect.X + 1, rect.Y + rect.Height - 2, rect.X + 1, rect.Y + 1)
                gr.DrawLine(p, rect.X + 1, rect.Y + 1, rect.X + rect.Width - 2, rect.Y + 1)
                p = New Pen(colors(2))
                gr.DrawLine(p, rect.X, rect.Y + rect.Height - 1, rect.X + rect.Width - 1, rect.Y + rect.Height - 1)
                gr.DrawLine(p, rect.X + rect.Width - 1, rect.Y + rect.Height - 1, rect.X + rect.Width - 1, rect.Y)
                p = New Pen(colors(3))
                gr.DrawLine(p, rect.X + 1, rect.Y + rect.Height - 2, rect.X + rect.Width - 2, rect.Y + rect.Height - 2)
                gr.DrawLine(p, rect.X + rect.Width - 2, rect.Y + rect.Height - 2, rect.X + rect.Width - 2, rect.Y + 1)
        End Select
    End Sub

    Private Sub HRectGauge_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        DrawGauge()
    End Sub

    Private Sub HRectGauge_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        DrawGauge()
    End Sub

    ' Set the control's Value based on this X coordinate.
    Private Sub SetValueFromX(ByVal X As Integer)
        Dim new_value As Integer = _
            CInt(m_Minimum + _
                (m_Maximum - m_Minimum) _
                    * (X - Me.DisplayRectangle.X) _
                    / Me.DisplayRectangle.Width)
        If new_value < m_Minimum Then new_value = m_Minimum
        If new_value > m_Maximum Then new_value = m_Maximum
        Value = new_value
    End Sub

    Private m_Dragging As Boolean
    Private Sub HRectGauge_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        SetValueFromX(e.X)
        m_Dragging = True
    End Sub

    Private Sub HRectGauge_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        If Not m_Dragging Then Exit Sub
        SetValueFromX(e.X)
    End Sub

    Private Sub HRectGauge_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        m_Dragging = False
        SetValueFromX(e.X)
    End Sub
End Class
